/*1:*/
#line 91 "eggdata.w"

#define REVDATE "17th February 2002"

/*:1*//*74:*/
#line 2233 "eggdata.w"


/*77:*/
#line 2466 "eggdata.w"


#include "config.h"         


#include <iostream> 
#include <exception> 
#include <stdexcept> 
#include <string> 

using namespace std;

#include <stdio.h> 
#include <stdlib.h> 
#include <ctype.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif
#include "eggdata.h"        


/*:77*/
#line 2235 "eggdata.w"
;

/*76:*/
#line 2448 "eggdata.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:76*/
#line 2237 "eggdata.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

int opt;

/*75:*/
#line 2416 "eggdata.w"

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:75*/
#line 2248 "eggdata.w"
;

#if 0

eggsummary es;

#if 0
ifstream ci("../test.csv");
es.load_from_CSV(ci);
ci.close();
#endif
es.load_from_CSV("../test.csv.gz");

for(int j= 0;j<es.eggs_reporting;j++){
cout<<es.egg_number[j]<<": "<<(int)es.get_egg_index(86399,j)<<"\n";
}
#endif

#if 1


{
egg_properties_database ed;

ed.loadFromCSV("eggs.csv");
ed.tabulate();
}
#endif

#if 0

{
eggdatabases ed;
systemtime t;

ed.set_Fourmilab_defaults();
t.fromString("2001-04-21 18:21:19");

cout<<ed.database_file(t)<<endl;
t.nextDay();
cout<<ed.database_file(t,"pseudo")<<endl;
}
#endif


#if 0

{int j;

eggsummary esr;
esr.load_from_CSV("../test.csv.gz");
int eggno= 7;

for(j= 0;j<10;j++){
cout<<j<<": "<<setw(3)<<((int)esr.get_egg_index(j,eggno))<<"  "<<
setw(3)<<((int)esr.get_egg_index((86400-10)+j,eggno))<<endl;
}

esr.time_shift(eggno,0);
cout<<endl<<" 0"<<endl;
for(j= 0;j<10;j++){
cout<<j<<": "<<setw(3)<<((int)esr.get_egg_index(j,eggno))<<"  "<<
setw(3)<<((int)esr.get_egg_index((86400-10)+j,eggno))<<endl;
}

esr.time_shift(eggno,-5);
cout<<endl<<" -5"<<endl;
for(j= 0;j<10;j++){
cout<<j<<": "<<setw(3)<<((int)esr.get_egg_index(j,eggno))<<"  "<<
setw(3)<<((int)esr.get_egg_index((86400-10)+j,eggno))<<endl;
}

esr.load_from_CSV("../test.csv.gz");
esr.time_shift(eggno,5);
cout<<endl<<" +5"<<endl;
for(j= 0;j<10;j++){
cout<<j<<": "<<setw(3)<<((int)esr.get_egg_index(j,eggno))<<"  "<<
setw(3)<<((int)esr.get_egg_index((86400-10)+j,eggno))<<endl;
}

esr.load_from_CSV("../test.csv.gz");
esr.time_shift(eggno,-90000);
cout<<endl<<" -90000"<<endl;
for(j= 0;j<10;j++){
cout<<j<<": "<<setw(3)<<((int)esr.get_egg_index(j,eggno))<<"  "<<
setw(3)<<((int)esr.get_egg_index((86400-10)+j,eggno))<<endl;
}
}
#endif

#if 0

{
eggdatabases ed;
ed.set_Fourmilab_defaults();
generic_eggsummary_cache<eggsummary> ec(&ed,"rotten_egg.csv",50,150);
eggsummary ext;

systemtime exstart,exend;

exstart.fromString("2001-04-20 13:00:00");
exend.fromString("2001-04-24 22:30:00");
ec.extract_time_range(&ext,exstart,exend);
ext.describe();
ext.save_to_CSV("/tmp/extract.csv",true);
}
#endif

#if 0

{int j;

eggsummary*es;
eggsummary_cache ec;

es= ec.get("../test.csv.gz");
eggsummary&esr= *es;

for(j= 0;j<esr.eggs_reporting;j++){
cout<<esr.egg_number[j]<<": "<<(int)esr.get_egg_index(86399,j)<<"\n";
}


es= ec.get("../test.csv.gz");
esr= *es;

for(j= 0;j<esr.eggs_reporting;j++){
cout<<esr.egg_number[j]<<": "<<(int)esr.get_egg_index(86399,j)<<"\n";
}
}
#endif

#if 0

while((cout<<"--> "),getline(cin,s)){
csv_parser p(s);
string f;

cout<<s;
cout<<"\n";

while(p.next_field(f)){
cout<<"{"+f+"}\n";
}
}
#endif

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}

/*:74*/
