/*33:*/
#line 719 "examples.w"

/*47:*/
#line 964 "examples.w"


/*51:*/
#line 1061 "examples.w"


#include "config.h"         
#define REVDATE "22nd February 2002" \

#define EGGS_CSV "eggs.csv"
#define ROTTEN_CSV "rotten_egg.csv" \


#line 1064 "examples.w"


#include "analysis.h"       
#include "fourier.h"     

#include <stdio.h> 
#include <stdlib.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif

/*:51*/
#line 966 "examples.w"
;

/*50:*/
#line 1040 "examples.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:50*/
#line 968 "examples.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

/*49:*/
#line 1006 "examples.w"

int opt;

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:49*/
#line 977 "examples.w"
;

/*:47*/
#line 720 "examples.w"
;

eggdatabases ed;
ed.set_local_defaults();
generic_eggsummary_cache<egganalysis> ec(&ed,ROTTEN_CSV,50,150);
egganalysis ext;
ec.extract_time_range(&ext,systemtime("2001-06-01 00:00:00"),
systemtime("2001-06-01 23:59:59"));

/*:33*//*34:*/
#line 733 "examples.w"

ext.compute_all_egg_statistics();
/*:34*//*35:*/
#line 744 "examples.w"


const int ftsize= 131072;
fourierTransform::complex vec[ftsize];
double ps[ftsize];
unsigned int nrows= ext.seconds_of_data/ext.seconds_per_row;
memset(vec,0,sizeof vec);
for(int n= 0;n<nrows;n++){
vec[n].r= ext.stouffer_z[n];
}
fourierTransform ft(ftsize);
ft.transform(vec);
ft.power_spectrum(vec,ps);

/*:35*//*36:*/
#line 765 "examples.w"

int aggregationBin= systemtime::SecondsPerHour;
int nbins= systemtime::SecondsPerDay/aggregationBin;

double*powerBin= new double[nbins];
int psv= 1;
for(int b= 0;b<nbins;b++){
powerBin[b]= 0;
for(int k= 0;k<aggregationBin;k++){
powerBin[b]+= ps[psv++];
}
}
/*:36*//*37:*/
#line 783 "examples.w"

string fileName= "example-8";

ofstream gp((fileName+".gp").c_str()),
dat((fileName+".dat").c_str());

for(int j= 0;j<nbins;j++){
dat<<j<<" "<<powerBin[j]<<endl;
}
delete powerBin;

gp<<"set term pbm small color"<<endl;
gp<<"plot \""<<fileName<<".dat\" using 1:2 with boxes"<<endl;
string command("gnuplot ");
command+= fileName+".gp | ppmtogif >"+fileName+".gif";
#undef DEV_PLOT_DEBUG
#ifdef DEV_PLOT_DEBUG
cout<<command<<endl;
#else
command+= " 2>/dev/null";
#endif
gp.close();
dat.close();
system(command.c_str());
#ifndef DEV_PLOT_DEBUG

remove((fileName+".gp").c_str());
remove((fileName+".dat").c_str());
#endif

/*:37*//*38:*/
#line 819 "examples.w"


/*48:*/
#line 983 "examples.w"

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}


/*:48*/
#line 821 "examples.w"
;


/*:38*/
