/*1:*/
#line 51 "fourier.w"

#define REVDATE "5th February 2002"

/*:1*//*17:*/
#line 407 "fourier.w"


/*20:*/
#line 593 "fourier.w"


#include "config.h"         


#include <iostream> 
#include <fstream> 
#include <exception> 
#include <stdexcept> 
#include <string> 
using namespace std;

#include <stdio.h> 
#include <stdlib.h> 
#include <ctype.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif
#include "fourier.h"        


/*:20*/
#line 409 "fourier.w"
;

/*19:*/
#line 575 "fourier.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:19*/
#line 411 "fourier.w"
;

#define FFTPOW  16
#define FFTSIZE (1 << FFTPOW)

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

int opt;

try{

/*18:*/
#line 543 "fourier.w"

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:18*/
#line 425 "fourier.w"
;

fourierTransform ft(FFTSIZE);

fourierTransform::complex a[FFTSIZE],b[FFTSIZE],c[FFTSIZE];


#define P1 773.0
#define A1 1
#define P2 593.0
#define A2 0.5
#define P3 191.0
#define A3 1
for(int i= 0;i<FFTSIZE;i++){
a[i].r= sin(static_cast<double> (i)/P1)*A1;
#ifdef P2
a[i].r+= sin(static_cast<double> (i)/P2)*A2;
#endif
#ifdef P3
a[i].r+= sin(static_cast<double> (i)/P3)*A3;
#endif
a[i].i= 0;
}

#ifdef CRAPTASTROPHE
b= a;
#else
memcpy(b,a,sizeof b);
#endif
ft.transform(b);

#ifdef CRAPTASTROPHE
c= b;
#else
memcpy(c,b,sizeof c);
#endif
ft.inverse_transform(c);

string fileName= "fourier";

ofstream gp((fileName+".gp").c_str()),
dat((fileName+".dat").c_str());









double pspec[FFTSIZE];
ft.power_spectrum(b,pspec);
#define PLOTSIZE 1000 
for(int j= 0;j<PLOTSIZE;j++){
c[j].r/= PLOTSIZE;
c[j].i/= PLOTSIZE;
dat<<j<<" "<<a[j].r<<" "<<pspec[j]<<" "<<c[j].r<<endl;
}

gp<<"set term pbm small color"<<endl;

#define PLOT_BOTH

#ifdef PLOT_INPUT
gp<<"plot \""<<fileName<<".dat\" using 1:2 with lines"<<endl;
#endif

#ifdef PLOT_INVERSE
gp<<"plot \""<<fileName<<".dat\" using 1:4 with lines"<<endl;
#endif

#ifdef PLOT_BOTH
gp<<"plot \""<<fileName<<".dat\" using 1:2 with lines, ";
gp<<"\""<<fileName<<".dat\" using 1:4 with lines"<<endl;
#endif

#ifdef PLOT_POWER 
gp<<"plot \""<<fileName<<".dat\" using 1:3 with lines"<<endl;
#endif

string command("gnuplot ");
command+= fileName+".gp | ppmtogif >"+fileName+".gif";
#ifdef DEV_PLOT_DEBUG
cout<<command<<endl;
#else
command+= " 2>/dev/null";
#endif
gp.close();
dat.close();
system(command.c_str());
#ifndef DEV_PLOT_DEBUG

remove((fileName+".gp").c_str());
remove((fileName+".dat").c_str());
#endif

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}

/*:17*/
