/*2:*/
#line 60 "plotting.w"

#include "config.h"                   


#line 63 "plotting.w"


/*4:*/
#line 101 "plotting.w"

#include "plotting.h"       

/*:4*/
#line 65 "plotting.w"

/*5:*/
#line 108 "plotting.w"

/*17:*/
#line 432 "plotting.w"

void csDeviceColour::hsv_rgb(double h,double s,double v,
double*r,double*g,double*b)
{
int i;
double f,p,q,t;

if(s==0){
*r= *g= *b= v;
}else{
if(h==360.0)
h= 0;
h/= 60.0;

i= (int)h;
f= h-i;
p= v*(1.0-s);
q= v*(1.0-(s*f));
t= v*(1.0-(s*(1.0-f)));
assert(i>=0&&i<=5);
switch(i){

case 0:
*r= v;
*g= t;
*b= p;
break;

case 1:
*r= q;
*g= v;
*b= p;
break;

case 2:
*r= p;
*g= v;
*b= t;
break;

case 3:
*r= p;
*g= q;
*b= v;
break;

case 4:
*r= t;
*g= p;
*b= v;
break;

case 5:
*r= v;
*g= p;
*b= q;
break;
}
}
}

/*:17*//*18:*/
#line 502 "plotting.w"

void csDeviceColour::rgb_hsv(double r,double g,double b,
double*h,double*s,double*v)
{
double imax= max(r,max(g,b)),
imin= min(r,min(g,b)),
rc,gc,bc;

*v= imax;
if(imax!=0)
*s= (imax-imin)/imax;
else
*s= 0;

if(*s==0){
*h= -1;
}else{
rc= (imax-r)/(imax-imin);
gc= (imax-g)/(imax-imin);
bc= (imax-b)/(imax-imin);
if(r==imax)
*h= bc-gc;
else if(g==imax)
*h= 2.0+rc-bc;
else
*h= 4.0+gc-rc;
*h*= 60.0;
if(*h<0.0)
*h+= 360.0;
}
}

/*:18*//*19:*/
#line 544 "plotting.w"

void csDeviceColour::rgb_hls(double r,double g,double b,
double*h,double*l,double*s)
{
double imax= max(r,max(g,b)),
imin= min(r,min(g,b)),
rc,gc,bc;

*l= (imax+imin)/2;

if(imax==imin){
*s= 0;
*h= -1;
}else{
if(*l<=0.5)
*s= (imax-imin)/(imax+imin);
else
*s= (imax-imin)/
(2.0-imax-imin);

rc= (imax-r)/(imax-imin);
gc= (imax-g)/(imax-imin);
bc= (imax-b)/(imax-imin);
if(r==imax)
*h= bc-gc;
else if(g==imax)
*h= 2.0+rc-bc;
else
*h= 4.0+gc-rc;
*h*= 60.0;
if(*h<0)
*h+= 360.0;
}
}

/*:19*//*20:*/
#line 585 "plotting.w"

double csDeviceColour::hlsval(double n1,double n2,double hue)
{
if(hue> 360.0)
hue-= 360.0;
else if(hue<0.0)
hue+= 360.0;
if(hue<60.0){
return n1+((n2-n1)*hue)/60.0;
}else if(hue<180.0){
return n2;
}else if(hue<240.0){
return n1+((n2-n1)*(240.0-hue))/60.0;
}else{
return n1;
}
}

void csDeviceColour::hls_rgb(double h,double l,double s,
double*r,double*g,double*b)
{
double m1,m2;

if(l<=0.5)
m2= l*(1.0+s);
else
m2= l+s-(l*s);
m1= 2*l-m2;

if(s==0){
*r= *g= *b= l;
}else{
*r= hlsval(m1,m2,h+120.0);
*g= hlsval(m1,m2,h);
*b= hlsval(m1,m2,h-120.0);
}
}

/*:20*//*21:*/
#line 635 "plotting.w"

void csDeviceColour::rgb_yiq(double r,double g,double b,
double*y,double*i,double*q)
{
double ay= (r*0.2989+g*0.5866+b*0.1144),
ai= (r*0.5959+g*-0.2741+b*-0.3218),
aq= (r*0.2113+g*-0.5227+b*0.3113);

*y= ay;
if(ay==1.0){
ai= aq= 0.0;
}
*i= ai;
*q= aq;
}

/*:21*//*22:*/
#line 671 "plotting.w"

void csDeviceColour::yiq_rgb(double y,double i,double q,
double*r,double*g,double*b)
{
double ar= (y+i*0.9562+q*0.6210),
ag= (y+i*-0.2717+q*-0.6485),
ab= (y+i*-1.1053+q*1.7020);

*r= max(0.0,min(1.0,ar));
*g= max(0.0,min(1.0,ag));
*b= max(0.0,min(1.0,ab));
}

/*:22*//*23:*/
#line 700 "plotting.w"

void csDeviceColour::rgb_yuv(double r,double g,double b,
double*y,double*u,double*v)
{
double ay= (r*0.2989+g*0.5866+b*0.1144),
au= (r*-0.1473+g*-0.2891+b*0.4364),
av= (r*0.6149+g*-0.5145+b*-0.1004);

*y= ay;
if(ay==1.0){
au= av= 0.0;
}
*u= au;
*v= av;
}

/*:23*//*24:*/
#line 734 "plotting.w"

void csDeviceColour::yuv_rgb(double y,double u,double v,
double*r,double*g,double*b)
{
double ar= (y+u*0.0000+v*1.1402),
ag= (y+u*-0.3959+v*-0.5810),
ab= (y+u*2.0294+v*0.0000);

*r= max(0.0,min(1.0,ar));
*g= max(0.0,min(1.0,ag));
*b= max(0.0,min(1.0,ab));
}

/*:24*//*25:*/
#line 765 "plotting.w"

void csDeviceColour::rgb_smpte_204M(double r,double g,double b,
double*y,double*Pb,double*Pr)
{
double ay= (r*0.2122+g*0.7013+b*0.0865),
aPb= (r*-0.1162+g*-0.3838+b*0.5000),
aPr= (r*0.5000+g*-0.4451+b*-0.0549);

*y= ay;
if(ay==1.0){
aPb= aPr= 0.0;
}
*Pb= aPb;
*Pr= aPr;
}

/*:25*//*26:*/
#line 800 "plotting.w"

void csDeviceColour::smpte_204M_rgb(double y,double Pb,double Pr,
double*r,double*g,double*b)
{
double ar= (y+Pb*0.0000+Pr*1.5755),
ag= (y+Pb*-0.2254+Pr*-0.4768),
ab= (y+Pb*1.8270+Pr*0.0000);

*r= max(0.0,min(1.0,ar));
*g= max(0.0,min(1.0,ag));
*b= max(0.0,min(1.0,ab));
}

/*:26*//*27:*/
#line 827 "plotting.w"

void csDeviceColour::rgb_cmy(double r,double g,double b,
double*c,double*m,double*y)
{
*c= 1.0-r;
*m= 1.0-g;
*y= 1.0-b;
}

/*:27*//*28:*/
#line 850 "plotting.w"

void csDeviceColour::cmy_rgb(double c,double m,double y,
double*r,double*g,double*b)
{
*r= 1.0-c;
*g= 1.0-m;
*b= 1.0-y;
}

/*:28*//*29:*/
#line 868 "plotting.w"

void csDeviceColour::cmy_cmyk(double c,double m,double y,
double*oc,double*om,double*oy,double*ok)
{
double k= min(c,min(m,y));

*oc= c-k;
*om= m-k;
*oy= y-k;
*ok= k;
}

/*:29*//*30:*/
#line 887 "plotting.w"

void csDeviceColour::cmyk_cmy(double c,double m,double y,double k,
double*oc,double*om,double*oy)
{
*oc= c+k;
*om= m+k;
*oy= y+k;
}

/*:30*//*31:*/
#line 902 "plotting.w"

void csDeviceColour::asHSV(double&h,double&s,double&v)
{
double r,g,b;

asRGB(r,g,b);
rgb_hsv(r,g,b,&h,&s,&v);
}

void csDeviceColour::asHLS(double&h,double&l,double&s)
{
double r,g,b;

asRGB(r,g,b);
rgb_hls(r,g,b,&h,&l,&s);
}

void csDeviceColour::asYIQ(double&y,double&i,double&q)
{
double r,g,b;

asRGB(r,g,b);
rgb_yiq(r,g,b,&y,&i,&q);
}

void csDeviceColour::asYUV(double&y,double&u,double&v)
{
double r,g,b;

asRGB(r,g,b);
rgb_yuv(r,g,b,&y,&u,&v);
}

void csDeviceColour::asSMPTE(double&y,double&Pb,double&Pr)
{
double r,g,b;

asRGB(r,g,b);
rgb_smpte_204M(r,g,b,&y,&Pb,&Pr);
}

void csDeviceColour::asCMY(double&c,double&m,double&y)
{
double r,g,b;

asRGB(r,g,b);
rgb_cmy(r,g,b,&c,&m,&y);
}

/*:31*/
#line 109 "plotting.w"


/*:5*/
#line 66 "plotting.w"


/*:2*/
