/*1:*/
#line 58 "timedate.w"

#define REVDATE "2nd February 2002"

/*:1*//*32:*/
#line 1377 "timedate.w"


/*35:*/
#line 1541 "timedate.w"


#include "config.h"         


#include <iostream> 
#include <exception> 
#include <stdexcept> 
#include <string> 
using namespace std;

#include <stdio.h> 
#include <stdlib.h> 
#include <ctype.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif
#include "timedate.h"        


/*:35*/
#line 1379 "timedate.w"
;

/*34:*/
#line 1523 "timedate.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:34*/
#line 1381 "timedate.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

int opt;

/*33:*/
#line 1491 "timedate.w"

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:33*/
#line 1390 "timedate.w"
;



string s;
systemtime td,td1;

td.now();
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
td1= td;
td1.nextDay();
cout<<"Tomorrow: "<<td1.dateToString()<<" "<<td1.timeToString()<<"\n";
td1= td;
td1.previousDay();
cout<<"Yesterday: "<<td1.dateToString()<<" "<<td1.timeToString()<<"\n";
td1= td;
td1.dayStep(7);
cout<<"Next week: "<<td1.dateToString()<<" "<<td1.timeToString()<<"\n";

td.fromString("1981-04-12 13:51:18");
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
td.fromString("2021-04-12");
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
cout<<"Weekday = "<<systemtime::jwday(systemtime::utctoj(2001,
5,12,23,59,59))<<"\n";
td.fromJulian(2436116.31);
cout<<td.dateToString()<<" "<<td.timeToString()<<"\n";
cout<<"To Julian = "<<td.toJulian()<<" Weekday = "<<td.weekday()<<"\n";
td.fromString("1987-04-10 19:21:00");
cout<<"Sidereal time = "<<angle::degrees_to_d_m_s(td.siderealTime())<<"\n";
cout.flush();
int t1,t2,t3;
systemtime::jyear(2436116.31,&t1,&t2,&t3);
printf("%04d-%02d-%02d\n",t1,t2,t3);
systemtime::jhms(systemtime::utctoj(1989,11,14,16,23,18),&t1,&t2,&t3);
printf("%02d:%02d:%02d\n",t1,t2,t3);

{
double j= 2446895.5;
double o= angle::rtd(systemtime::meanObliquityOfEcliptic(j));
double delpsi,deleps;

cout<<"meanObliquityOfEcliptic("<<((long)j)<<") = "<<
angle::degrees_to_d_m_s(o)<<"\n";
systemtime::nutation(j,&delpsi,&deleps);
cout<<"  delpsi = "<<
angle::degrees_to_d_m_s(angle::rtd(delpsi))<<
" deleps = "<<
angle::degrees_to_d_m_s(angle::rtd(deleps))<<"\n";

double eOt= systemtime::equationTime(2448908.5);
cout<<"Equation of time = "<<((int)(eOt/60))<<" minutes "<<
(eOt-(60*((int)(eOt/60))))<<" seconds\n";

j= 2448908.5;
double sura,sudec,surv,suslong;
systemtime::sunpos(j,true,
&sura,&sudec,&surv,&suslong);
cout<<"Sun position:  RA = "<<angle::rtd(sura)<<
"  Dec = "<<angle::rtd(sudec)<<"  Rv = "<<surv<<
"  Long = "<<angle::rtd(suslong)<<"\n";
}

{
double phaseang,pphase,mage,dist,angdia,
sudist,suangdia;

systemtime::moon_and_sun(2452060.13874,
&phaseang,&pphase,&mage,&dist,&angdia,
&sudist,&suangdia);

cout<<"Moon:  Phaseang = "<<(phaseang*100)<<
"  Pphase = "<<((int)(pphase*100))<<"%\n       "<<
"  Moon age = "<<((int)mage)<<" days, "<<
angle::degrees_to_d_m_s((mage-((int)mage))*24)<<
"  Dist = "<<dist<<" km\n"<<
"Sun:   Angdia = "<<angle::rtd(angdia)<<
"  Sudist = "<<((int)sudist)<<" km"<<
"  Suangdia = "<<angle::rtd(suangdia)<<"\n";
}

{
double phases[5];
systemtime pt[5];
int i;

systemtime::moonphases(2452060.13874,phases);
for(i= 0;i<5;i++){
pt[i].fromJulian(phases[i]);
cout<<"Phase "<<i<<": "<<pt[i].dateToString()<<
" "<<pt[i].timeToString()<<"\n";
}
}

return 0;
}

/*:32*/
